#!/usr/bin/env python3

import argparse
from pythonosc import udp_client
from sys import exit
import os
import numpy as np
import threading

DESCRIPTION = "Tool to take f32le samples from pipe (stdin) and send them as OSC /signal messages."
EPILOG = """Example of sending test signal generated by gst-launch : 
gst-launch-1.0 --quiet \
	audiotestsrc \
		is-live=true \
		wave=sine \
		freq=0.2 \
		volume=1.0 \
		samplesperbuffer=4 \
	! audio/x-raw,format=F32LE,layout=interleaved,rate=400,channels=4 \
	! fdsink \
	| ./mmesh-pipe-osc.py --channels 4 --address 10.0.0.101
"""

# application threads stop signal
task_stop_signal = threading.Event()

# global variables
channels = 4

# OSC client global variables
address = "127.0.0.1"
port = "9000"


def read_task():
    """Thread task reading data from stdin"""
    print("Starting read task.")

    # read loop
    while True:
        if task_stop_signal.is_set():
            break

        # read one frame, exit loop if frame smaller than requested
        raw_frame = os.read(0, 4 * channels)
        if len(raw_frame) < 4 * channels:
            break

        decoded_frame = np.frombuffer(raw_frame, dtype="<f4", count=channels)
        # print(f"decoded_frame: {decoded_frame.tolist()}")
        client.send_message("/signal", decoded_frame.tolist())

    print("Read task done.")


def stop():
    """Register a stop signal informing all thread tasks to stop their work"""
    task_stop_signal.set()
    print("\n\nExiting...")


def handler(signal_received, frame):
    """Signal handler to stop when receiving SIGINT"""
    stop()


if __name__ == "__main__":
    parser = argparse.ArgumentParser(description=DESCRIPTION, epilog=EPILOG)
    parser.add_argument(
        "--address",
        default="127.0.0.1",
        help="The IP or hostname address to send OSC to",
    )
    parser.add_argument(
        "--port", type=int, default=9000, help="The port to send OSC to"
    )
    parser.add_argument(
        "--channels",
        type=int,
        default=4,
        help="The number of channels to accept from stdin (1 to 10000)",
    )

    args = parser.parse_args()

    address = args.address
    port = args.port

    channels = args.channels
    if channels < 1 or channels > 10000:
        print(
            f"Invalid number of channels: {channels}. ",
            "Only 1 to 10000 is valid.",
        )
        exit(1)

    client = udp_client.SimpleUDPClient(address, port)

    read_task_thread = threading.Thread(target=read_task)

    read_task_thread.start()
